Index: waeup/trunk/src/waeup/ftesting.zcml
===================================================================
--- waeup/trunk/src/waeup/ftesting.zcml	(revision 3551)
+++ waeup/trunk/src/waeup/ftesting.zcml	(revision 4789)
@@ -10,5 +10,5 @@
   <!-- Typical functional testing security setup -->
   <securityPolicy
-      component="zope.app.securitypolicy.zopepolicy.ZopeSecurityPolicy"
+      component="zope.securitypolicy.zopepolicy.ZopeSecurityPolicy"
       />
 
@@ -17,7 +17,29 @@
       title="Unauthenticated User"
       />
+  <unauthenticatedGroup id="zope.Anybody"
+      title="Unauthenticated Users" />
+  <authenticatedGroup id="zope.Authenticated"
+      title="Authenticated Users" />
+  <everybodyGroup id="zope.Everybody"
+      title="All Users" />
+
   <grant
       permission="zope.View"
-      principal="zope.anybody"
+      principal="zope.Anybody"
+      />
+  <grant
+      permission="zope.app.dublincore.view"
+      principal="zope.Anybody" />
+  <grant
+      permission="zope.View"
+      principal="zope.Authenticated"
+      />
+  <grant
+      permission="zope.app.dublincore.view"
+      principal="zope.Authenticated"
+      />
+  <grant
+      permission="waeup.Public"
+      principal="zope.Everybody"
       />
 
Index: waeup/trunk/src/waeup/hostel/hostel.py
===================================================================
--- waeup/trunk/src/waeup/hostel/hostel.py	(revision 3551)
+++ waeup/trunk/src/waeup/hostel/hostel.py	(revision 4789)
@@ -1,8 +1,6 @@
 import grok
-from waeup.baseitem import BaseItem
-from interfaces import IHostel
+from waeup.interfaces import IHostel
 
-
-class Hostel(BaseItem):
+class Hostel(grok.Container):
     """This is a hostel record.
     """    
@@ -12,2 +10,4 @@
         super(Hostel, self).__init__(**kw)
         self.name = name
+
+grok.global_utility(Hostel, provides=IHostel)
Index: waeup/trunk/src/waeup/hostel/hostelcontainer.py
===================================================================
--- waeup/trunk/src/waeup/hostel/hostelcontainer.py	(revision 3551)
+++ waeup/trunk/src/waeup/hostel/hostelcontainer.py	(revision 4789)
@@ -1,6 +1,36 @@
-from waeup.basecontainer import BaseContainer
-from hostel import Hostel
+import grok
+from zope.component.interfaces import IFactory
+from zope.interface import implementedBy
+from waeup.interfaces import IHostelContainer, IHostel
 
-class HostelContainer(BaseContainer):
-    name = u"Hostels"
-    childClass = Hostel
+class HostelContainer(grok.Container):
+
+    grok.implements(IHostelContainer)
+    grok.require('waeup.manageUniversity')
+
+    # A simple counter for ids.
+    next_id = 0L
+
+    def addHostel(self, hostel):
+        if not IHostel.providedBy(hostel):
+            raise TypeError('HostelContainers contain only IHostel instances')
+        id = str(self.next_id)
+        self[id] = hostel
+        while self.next_id in self.keys():
+            # Look for next unused int...
+            self.next_id += 1
+        return id
+
+class HostelContainerFactory(grok.GlobalUtility):
+    """A factory for faculty containers.
+    """
+    grok.implements(IFactory)
+    grok.name(u'waeup.HostelContainer')
+    title = u"Create a new hostel container.",
+    description = u"This factory instantiates new hostel containers."
+
+    def __call__(self):
+        return HostelContainer()
+
+    def getInterfaces(self):
+        return implementedBy(HostelContainer)
Index: waeup/trunk/src/waeup/interfaces.py
===================================================================
--- waeup/trunk/src/waeup/interfaces.py	(revision 3551)
+++ waeup/trunk/src/waeup/interfaces.py	(revision 4789)
@@ -1,8 +1,39 @@
 ##
 ## interfaces.py
-from zope.interface import Interface
+from zc.sourcefactory.basic import BasicSourceFactory
+from zope.component import getUtility
+from zope.app.catalog.interfaces import ICatalog
+from zope.interface import Interface, Attribute
 from zope import schema
-
-class IUniversity(Interface):
+from zope.schema.vocabulary import SimpleVocabulary, SimpleTerm
+from waeup.permissions import RoleSource
+
+def SimpleWAeUPVocabulary(*terms):
+    """A well-buildt vocabulary provides terms with a value, token and
+       title for each term
+    """
+    return SimpleVocabulary([
+            SimpleTerm(value, value, title) for title, value in terms])
+
+
+class CourseSource(BasicSourceFactory):
+    """A course source delivers all courses inside the portal by looking
+       up a catalog.
+    """
+    catalog = None
+    def getValues(self):
+        if self.catalog is None:
+            self.catalog = getUtility(ICatalog, name='courses_catalog')
+        return list(self.catalog.searchResults(code=('', 'z*')))
+        
+    def getTitle(self, value):
+        return "%s %s" % (value.code, value.title[:32])
+
+
+class IWAeUPObject(Interface):
+    """A WAeUP object.
+    """
+
+class IUniversity(IWAeUPObject):
     """Representation of a university.
     """
@@ -12,2 +43,369 @@
         required = True,
         )
+
+    faculties = Attribute("A container for faculties.")
+    students = Attribute("A container for students.")
+    hostels = Attribute("A container for hostels.")
+    
+class IWAeUPContainer(IWAeUPObject):
+    """A container for WAeUP objects.
+    """
+
+class IWAeUPContained(IWAeUPObject):
+    """An item contained in an IWAeUPContainer.
+    """
+    
+class IStudentContainer(IWAeUPContainer):
+    """A container for StudentObjects.
+    """
+
+class IFaculty(IWAeUPContainer):
+    """Representation of a university faculty.
+    """
+    title = schema.TextLine(
+        title = u'Name of Faculty',
+        default = u'Unnamed',
+        required = True,
+        )
+
+    title_prefix = schema.TextLine(
+        title = u'Title prefix',
+        default = u'faculty',
+        required = True,
+        )
+    
+    code = schema.TextLine(
+        title = u'Code',
+        description = u'Abbreviated code of the faculty',
+        default = u'NA',
+        required = True,
+        )
+
+class IFacultyContainer(IWAeUPContainer):
+    """A container for faculties.
+    """
+    def addFaculty(faculty):
+        """Add an IFactulty object.
+
+        Returns the key, under which the object was stored.
+        """
+
+class IHostelContainer(IWAeUPContainer):
+    """A container for hostels.
+    """
+    def addHostel(hostel):
+        """Add an IHostel object.
+
+        Returns the key, under which the object was stored.
+        """
+
+class IHostel(IWAeUPObject):
+    """Representation of a hostel.
+    """
+    name = schema.TextLine(
+        title = u'Name of Hostel',
+        default = u'Nobody',
+        required = True,
+        )
+
+class IDepartment(IWAeUPObject):
+    """Representation of a department.
+    """
+    title = schema.TextLine(
+        title = u'Name of Department',
+        default = u'Unnamed',
+        required = True,
+        )
+
+    title_prefix = schema.TextLine(
+        title = u'Title prefix',
+        default = u'department',
+        required = True,
+        )
+    
+    code = schema.TextLine(
+        title = u'Code',
+        default = u'NA',
+        description = u'Abbreviated code of the department',
+        required = True,
+        )
+
+    courses = Attribute("A container for courses.")
+    certificates = Attribute("A container for certificates.")
+
+
+class ICourseContainer(IWAeUPContainer):
+    """A container for faculties.
+    """
+    def addCourse(faculty):
+        """Add an ICourse object.
+
+        Returns the key, under which the object was stored.
+        """
+
+class ICourse(IWAeUPObject):
+    """Representation of a course.
+    """
+    code = schema.TextLine(
+        title = u'Code',
+        default = u'NA',
+        description = u'Abbreviated code of the course',
+        required = True,
+        readonly = True,
+        )
+
+    title = schema.TextLine(
+        title = u'Title of course',
+        default = u'Unnamed',
+        required = True,
+        )
+
+    level = schema.TextLine(
+        title = u'Level',
+        default = u'100',
+        required = False,
+        )
+
+    credits = schema.Int(
+        title = u'Credits',
+        default = 0,
+        required = False,
+        )
+    
+    passmark = schema.Int(
+        title = u'Passmark',
+        default = 40,
+        required = False,
+        )
+
+    semester = schema.Choice(
+        title = u'Semester/Term',
+        default = 0,
+        vocabulary = SimpleWAeUPVocabulary(
+            ('N/A', 0), ('First Semester', 1),
+            ('Second Semester', 2), ('Combined', 3)),
+        required = True,
+        )
+
+
+class ICertificate(IWAeUPObject):
+    """Representation of a certificate.
+    """
+    code = schema.TextLine(
+        title = u'Code',
+        default = u'NA',
+        description = u'Abbreviated code of the certificate.',
+        required = True,
+        )
+
+    review_state = schema.Choice(
+        title = u'review state',
+        values = ['unchecked', 'checked']
+        )
+
+    title = schema.TextLine(
+        title = u'title',
+        required = True,
+        )
+
+    category = schema.TextLine(
+        title = u'category',
+        required = True,
+        )
+
+    study_mode = schema.TextLine(
+        title = u'study mode',
+        required = True,
+        )
+
+    start_level = schema.TextLine(
+        title = u'start level',
+        required = True,
+        )
+    
+    end_level = schema.TextLine(
+        title = u'end level',
+        required = True,
+        )
+    
+    application_category = schema.TextLine(
+        title = u'application category',
+        required = True,
+        )
+    
+    m_prefix = schema.TextLine(
+        title = u'prefix',
+        required = True,
+        )
+        
+    max_pass = schema.TextLine(
+        title = u'maximum pass',
+        required = True,
+        )
+    
+
+    
+class ICertificateContainer(IWAeUPContainer):
+    """A container for certificates.
+    """
+    def addCertificate(faculty):
+        """Add an ICertificate object.
+
+        Returns the key, under which the object was stored.
+        """
+
+class ICertificateCourse(IWAeUPObject):
+    """A certificatecourse is a course referenced by a certificate, which
+       provides some own attributes.
+    """
+    course = schema.Choice(
+        title = u'Course',
+        source = CourseSource(),
+        )
+    
+    level = schema.Int(
+        title = u'Level of this course',
+        required = True,
+        default = 100
+        )
+
+    core_or_elective = schema.Bool(
+        title = u'Is mandatory course (not elective)',
+        required = True,
+        default = True
+        )
+
+    def getCourseCode():
+        """Return the code of the referenced course.
+
+        This is needed for cataloging.
+        """
+        
+class IWAeUPExporter(Interface):
+    """An exporter for objects.
+    """
+    def export(obj, filepath=None):
+        """Export by pickling.
+
+        Returns a file-like object containing a representation of `obj`.
+
+        This is done using `pickle`. If `filepath` is ``None``, a
+        `cStringIO` object is returned, that contains the saved data.
+        """
+
+class IWAeUPXMLExporter(Interface):
+    """An XML exporter for objects.
+    """
+    def export(obj, filepath=None):
+        """Export as XML.
+
+        Returns an XML representation of `obj`.
+
+        If `filepath` is ``None``, a StringIO` object is returned,
+        that contains the transformed data.
+        """
+
+class IWAeUPXMLImporter(Interface):
+    """An XML import for objects.
+    """
+    def doImport(filepath):
+        """Create Python object from XML.
+
+        Returns a Python object.
+        """
+
+class IWAeUPCSVExporter(Interface):
+    """A CSV exporter for objects.
+    """
+
+    def export(obj, filepath=None):
+        """Export as CSV.
+
+        Returns a CSV representation of `obj`.
+
+        If `filepath` is ``None``, a StringIO` object is returned,
+        that contains the transformed data.
+        """
+
+class IWAeUPCSVImporter(Interface):
+    """A CSV importer for objects.
+    """
+    datatype = schema.TextLine(
+        title = u'Data type',
+        description = u'Type of data supported by this filter.',
+        required = True,)
+
+    def doImport(clear_old_data=True, overwrite=True):
+        """Read data from `filepath` and apply data.
+
+        It depends on the context, what 'applying data' means here.
+
+        If `clear_old_data` is False, old data will be
+        preserved. Otherwise all old data will get lost.
+
+        If `overwrite` is False, any existing entries with similar
+        keys might be overwritten. This option is ignored, when
+        `clear_old_data` is set to True.
+        """
+        
+class IUserAccount(IWAeUPObject):
+    """A user account.
+    """
+    name = schema.TextLine(
+        title = u'User ID',
+        description = u'Loginname',
+        required = True,)
+    title = schema.TextLine(
+        title = u'Username',
+        description = u'Real name',
+        required = False,)
+    description = schema.TextLine(
+        title = u'User description',
+        required = False,)
+    password = schema.Password(
+        title = u'Password',
+        required = True,)
+    roles = schema.List(
+        title = u'Roles',
+        value_type = schema.Choice(source=RoleSource()))
+    
+    
+class IUserContainer(IWAeUPObject):
+    """A container for users (principals).
+
+    These users are used for authentication purposes.
+    """
+
+    def addUser(name, password, title=None, description=None):
+        """Add a user.
+        """
+
+    def delUser(name):
+        """Delete a user if it exists.
+        """
+
+class IDataCenter(IWAeUPObject):
+    """A data center.
+
+    TODO : declare methods, at least those needed by pages.
+    """
+    pass
+
+class ICSVDataReceivers(Interface):
+    """An object containing things ready for CSV imports.
+
+    This is pure marker interface. Objects that implement it, indicate
+    that they might provide attributes, which are able to receive CSV
+    data, i.e. for which an IWAeUPCSVDataImporter exists.
+    """
+
+class IDataCenterFile(Interface):
+    """A data center file.
+    """
+    def getDate():
+        """Get creation timestamp from file in human readable form.
+        """
+
+    def getSize():
+        """Get human readable size of file.
+        """
Index: waeup/trunk/src/waeup/permissions.py
===================================================================
--- waeup/trunk/src/waeup/permissions.py	(revision 3551)
+++ waeup/trunk/src/waeup/permissions.py	(revision 4789)
@@ -1,5 +1,61 @@
 import grok
+from zc.sourcefactory.basic import BasicSourceFactory
 
+class Public(grok.Permission):
+    """Everyone-can-do-this-permission.
+
+    This permission is meant to be applied to objects/views/pages
+    etc., that should be usable/readable by everyone.
+
+    We need this to be able to tune default permissions more
+    restrictive and open up some dedicated objects like the front
+    page.
+    """
+    grok.name('waeup.Public')
+
+class ViewPermission(grok.Permission):
+    grok.name('waeup.View')
+
+class ManageUniversity(grok.Permission):
+    grok.name('waeup.manageUniversity')
+
+class ManageUsers(grok.Permission):
+    grok.name('waeup.manageUsers')
+    
 class FacultyRead(grok.Permission):
     grok.name('waeup.facultyread')
+    
+class PortalUser(grok.Role):
+    grok.name('waeup.PortalUser')
+    grok.permissions('waeup.facultyread', 'waeup.View', 'waeup.Public')
 
+class PortalManager(grok.Role):
+    grok.name('waeup.PortalManager')
+    grok.permissions('waeup.manageUniversity', 'waeup.manageUsers',
+                     'waeup.View', 'waeup.Public')
+
+def getRoles():
+    app = grok.getSite()
+    app = None
+    manager = None
+    if app is not None:
+        from zope.securitypolicy.interfaces import IRolePermissionManager
+        manager = IRolePermissionManager(app, None)
+    else:
+        from zope.securitypolicy.rolepermission import (
+            rolePermissionManager as manager)
+    role_permission_map =  manager.getRolesAndPermissions()
+    result = dict()
+    for item in role_permission_map:
+        if not item[1].startswith('waeup.'):
+            # Ignore non-WAeUP roles...
+            continue
+        result[item[1]] = True
+    return sorted(result.keys())
+
+class RoleSource(BasicSourceFactory):
+    def getValues(self):
+        return getRoles()
+    def getTitle(self, value):
+        if isinstance(value, basestring):
+            return value.split('.', 2)[1]
Index: waeup/trunk/src/waeup/static/pagelayout.js
===================================================================
--- waeup/trunk/src/waeup/static/pagelayout.js	(revision 4789)
+++ waeup/trunk/src/waeup/static/pagelayout.js	(revision 4789)
@@ -0,0 +1,64 @@
+(function() {
+    var Dom = YAHOO.util.Dom,
+        Event = YAHOO.util.Event;
+
+    Event.onDOMReady(function() {
+        var layout = new YAHOO.widget.Layout({
+            units: [
+                /* header */
+                { position: 'top', height: 114, body: 'hd',
+                  gutter: '1px' },
+                /* footer */
+                { position: 'bottom', height: 30,
+                  body: 'ft', gutter: '-1px' },
+                /* left sidebar */
+                { position: 'left', header: 'Actions', width: 200, resize: true,
+                  body: 'left', gutter: '5px', collapse: true,
+                  collapseSize: 25, scroll: true, animate: true },
+                /* main area */
+	  { position: 'center', body: 'yui-main', scroll: true }
+            ]
+        });
+        layout.on('render', function() {
+            layout.getUnitByPosition('left').on('close', function() {
+                closeLeft();
+            });
+        });
+        layout.render();
+        Event.on('tLeft', 'click', function(ev) {
+            Event.stopEvent(ev);
+            layout.getUnitByPosition('left').toggle();
+        });
+        Event.on('padRight', 'click', function(ev) {
+            Event.stopEvent(ev);
+            var pad = prompt('CSS gutter to apply: ("2px" or "2px 4px" or any combination of the 4 sides)', layout.getUnitByPosition('right').get('gutter'));
+            layout.getUnitByPosition('right').set('gutter', pad);
+        });
+        var closeLeft = function() {
+            var a = document.createElement('a');
+            a.href = '#';
+            a.innerHTML = 'Add Left Unit';
+            Dom.get('closeLeft').parentNode.appendChild(a);
+
+            Dom.setStyle('tLeft', 'display', 'none');
+            Dom.setStyle('closeLeft', 'display', 'none');
+            Event.on(a, 'click', function(ev) {
+                Event.stopEvent(ev);
+                Dom.setStyle('tLeft', 'display', 'inline');
+                Dom.setStyle('closeLeft', 'display', 'inline');
+                a.parentNode.removeChild(a);
+                layout.addUnit(layout.get('units')[3]);
+                layout.getUnitByPosition('left').on('close', function() {
+                    closeLeft();
+                });
+            });
+        };
+        Event.on('closeLeft', 'click', function(ev) {
+            Event.stopEvent(ev);
+            layout.getUnitByPosition('left').close();
+        });
+    });
+
+
+})();
+
Index: waeup/trunk/src/waeup/student/interfaces.py
===================================================================
--- waeup/trunk/src/waeup/student/interfaces.py	(revision 4789)
+++ waeup/trunk/src/waeup/student/interfaces.py	(revision 4789)
@@ -0,0 +1,14 @@
+##
+## interfaces.py
+from zope.interface import Interface
+from zope import schema
+
+class IStudent(Interface):
+    """Representation of a student.
+    """
+    name = schema.TextLine(
+        title = u'Name of student',
+        default = u'Nobody',
+        required = True,
+        )
+
Index: waeup/trunk/src/waeup/student/student.py
===================================================================
--- waeup/trunk/src/waeup/student/student.py	(revision 4789)
+++ waeup/trunk/src/waeup/student/student.py	(revision 4789)
@@ -0,0 +1,73 @@
+import grok
+from grok import index
+from waeup.student.interfaces import IStudent
+
+def fromCsv(a):
+    #Factory method
+    student = Student("Dummy")
+    student.entry_mode, student.end_level, student.name, student.jamb_reg_no, student.level, student.id, student.lga, student.entry_session, student.matric_no, student.sex, student.phone, student.session, student.course, student.mode, student.faculty, student.department, student.verdict, student.review_state,  student.perm_address, student.email = a
+    return student
+
+class Student(grok.Model):
+    """This is a student record.
+    """
+    grok.implements(IStudent)
+
+    #TODO: REFACTOR TO SCHEMA
+    fields = [   "entry_mode",
+                 "end_level",
+                 "name",
+                 "jamb_reg_no",
+                 "level",
+                 "id",
+                 "lga",
+                 "entry_session",
+                 "matric_no",
+                 "sex",
+                 "phone",
+                 "session",
+                 "course",
+                 "mode",
+                 "faculty",
+                 "department",
+                 "verdict",
+                 "review_state",
+                 "perm_address",
+                 "email"
+            ]
+
+    def __init__(self, name=None):
+        """
+        TODO: REFACTOR TO IMPORT METHOD
+        Fields:
+                 entry_mode,
+                 end_level,
+                 name,
+                 jamb_reg_no,
+                 level,
+                 id,
+                 lga,
+                 entry_session,
+                 matric_no,
+                 sex,
+                 phone,
+                 session,
+                 course,
+                 mode,
+                 faculty,
+                 department,
+                 verdict,
+                 review_state,
+                 perm_address,
+                 email
+
+        """
+        self.name = name
+        
+
+    def getCsv(self):
+        #return self.entry_mode, self.end_level, self.name, self.jamb_reg_no, self.level, self.id, self.lga, self.entry_session, self.matric_no, self.sex, self.phone, self.session, self.course, self.mode, self.faculty, self.department, self.verdict, self.review_state,  self.perm_address, self.email
+        return [getattr(self, field, u"") for field in self.fields]
+
+
+grok.global_utility(Student, provides=IStudent)
Index: waeup/trunk/src/waeup/student/studentcontainer.py
===================================================================
--- waeup/trunk/src/waeup/student/studentcontainer.py	(revision 4789)
+++ waeup/trunk/src/waeup/student/studentcontainer.py	(revision 4789)
@@ -0,0 +1,54 @@
+import grok
+import os
+from zope.component.interfaces import IFactory
+from zope.interface import implementedBy
+from waeup.interfaces import IStudentContainer
+from waeup.utils import importexport as csv
+
+class StudentContainer(grok.Container):
+    """
+    The node containing the student models
+    """
+
+    grok.implements(IStudentContainer)
+    
+class StudentContainerFactory(grok.GlobalUtility):
+    """A factory for faculty containers.
+    """
+    grok.implements(IFactory)
+    grok.name(u'waeup.StudentContainer')
+    title = u"Create a new student container.",
+    description = u"This factory instantiates new student containers."
+
+    def __call__(self):
+        return StudentContainer()
+
+    def getInterfaces(self):
+        return implementedBy(StudentContainer)
+    
+class Import(grok.View):
+    def render(self):
+        #XXX TODO: Make import form to choose csv-file
+        t = [0]
+        src = os.path.join(os.path.dirname(__file__), '..', 'tests',
+                           'TestData','Students.csv')
+        inputfile = file(src, "r")
+        num = 0
+        headers, rows = csv.readFile(inputfile)
+        for i in rows:
+             s = fromCsv(i)
+             self.context[str(num)] = s
+             num += 1
+             if num > 100:
+                 break
+        return "%s new Students added in %s" % (num, t[0])
+
+class Export(grok.View):    
+    def render(self):
+        #XXX TODO: Make export form to choose csv-file
+        t = [0]
+        result = []
+        for s in self.context.values():
+             result.append(s.getCsv())
+        csv.writeFile(result)
+        return "yeah %s" % t[0]
Index: waeup/trunk/src/waeup/tables.py
===================================================================
--- waeup/trunk/src/waeup/tables.py	(revision 4789)
+++ waeup/trunk/src/waeup/tables.py	(revision 4789)
@@ -0,0 +1,155 @@
+"""Datatables and related components used in different contexts.
+"""
+import grok
+from waeup.interfaces import (IUniversity, IFacultyContainer, IFaculty,
+                              IDepartment, ICourseContainer)
+from waeup.widgets.interfaces import ITableProvider
+from waeup.widgets.table import YUITable as Table
+from waeup.widgets.table import Col
+from zope.security.management import checkPermission
+
+class CodeAndTitleTableProvider(grok.Adapter):
+    """A table provider for objects that have a code, title and prefix.
+    """
+    grok.baseclass()
+    grok.provides(ITableProvider)
+
+    title = None
+
+    def __init__(self, context):
+        self.context = context
+        self.prepare()
+
+    def prepare(self):
+        self.data_source = self.context
+
+    def getItemURL(self, view, value):
+        context_url = ''
+        if not view is None:
+            context_url = view.url(self.data_source) + '/'
+        result = '<a href="%s%s">%s</a>' % (context_url, value, value)
+        return result
+    
+    def getTables(self, view=None):
+        data = self.data_source
+        context_url = ''
+        if view:
+            context_url = view.url(self.context) + '/'
+        cols = (
+            Col(
+                header='Code', sortable=True,
+                data = tuple([self.getItemURL(view, data[x].code)
+                              for x in data])),
+            Col(
+                header='Title', sortable=True,
+                data = tuple([data.getName(x) for x in data])),
+            )
+        self.table = Table(self.title, cols=cols)
+        return (self.table,)
+    
+class DepartmentTableProvider(CodeAndTitleTableProvider):
+    grok.context(IFaculty)
+    grok.provides(ITableProvider)
+    title = 'Departments'
+
+class FacultyTableProvider(CodeAndTitleTableProvider):
+    grok.context(IFacultyContainer)
+    grok.provides(ITableProvider)
+    title = 'Faculties'
+
+class UniversityTableProvider(CodeAndTitleTableProvider):
+    grok.context(IUniversity)
+    grok.provides(ITableProvider)
+    title = 'Faculties'
+
+    def prepare(self):
+        self.data_source = self.context.faculties
+
+class CourseTableProvider(CodeAndTitleTableProvider):
+    grok.context(IDepartment)
+    grok.provides(ITableProvider)
+    title = 'Courses'
+
+    def prepare(self):
+        self.data_source = self.context.courses
+        
+    def getTables(self, view=None):
+        data = self.data_source
+        context_url = ''
+        if view:
+            context_url = view.url(self.context) + '/'
+
+        # Create a courses table...
+        cols = (
+            Col(
+                header='Code', sortable=True,
+                data = tuple([self.getItemURL(view, data[x].code)
+                              for x in data])),
+            Col(
+                header='Title', sortable=True,
+                data = tuple([data[x].title for x in data])),
+            )
+        delcol = Col(header='', sortable=False,
+                     data = [
+                '<form method="post">'
+                '<input type="submit" name="delcourse" value="Delete" />'
+                '<input type="hidden" name="code" value="%s" />'
+                '</form>' % (data[x].code)
+                for x in data])
+
+        if checkPermission('waeup.manageUniversity', self.context.courses):
+            cols = list(cols)
+            cols.append(delcol)
+            cols = tuple(cols)
+        self.coursetable = Table('Courses', cols=cols)
+
+        # Create a certificates table...
+        self.data_source = self.context.certificates
+        data = self.data_source
+        certcols =(
+            Col(
+                header='Code', sortable=True,
+                data = tuple([self.getItemURL(view, data[x].code)
+                              for x in data])),
+            Col(
+                header='Title', sortable=True,
+                data = tuple([data[x].title for x in data])),
+            )
+
+        delcol = Col(header='', sortable=False,
+                     data = [
+                '<form method="post">'
+                '<input type="submit" name="delcert" value="Delete" />'
+                '<input type="hidden" name="code" value="%s" />'
+                '</form>' % (data[x].code)
+                for x in data])
+
+        if checkPermission('waeup.manageUniversity', self.context.certificates):
+            certcols = list(certcols)
+            certcols.append(delcol)
+            certcols = tuple(certcols)
+
+        self.certtable = Table('Certificates', cols=certcols)
+        return (self.coursetable, self.certtable)
+
+class CourseContainerCourseTableProvider(CodeAndTitleTableProvider):
+    grok.context(ICourseContainer)
+    grok.provides(ITableProvider)
+    title = 'Courses'
+
+    def getTables(self, view=None):
+        data = self.data_source
+        context_url = ''
+        if view:
+            context_url = view.url(self.context) + '/'
+        cols = (
+            Col(
+                header='Code', sortable=True,
+                data = tuple([self.getItemURL(view, data[x].code)
+                              for x in data])),
+            Col(
+                header='Title', sortable=True,
+                data = tuple([data[x].title for x in data])),
+            )
+        self.table = Table(self.title, cols=cols)
+        return (self.table,)
Index: waeup/trunk/src/waeup/testing.py
===================================================================
--- waeup/trunk/src/waeup/testing.py	(revision 3551)
+++ waeup/trunk/src/waeup/testing.py	(revision 4789)
@@ -5,3 +5,4 @@
 ftesting_zcml = os.path.join(
     os.path.dirname(waeup.__file__), 'ftesting.zcml')
-FunctionalLayer = ZCMLLayer(ftesting_zcml, __name__, 'FunctionalLayer')
+FunctionalLayer = ZCMLLayer(ftesting_zcml, __name__, 'FunctionalLayer',
+                            allow_teardown=True)
Index: waeup/trunk/src/waeup/tests/test_waeup.py
===================================================================
--- waeup/trunk/src/waeup/tests/test_waeup.py	(revision 3551)
+++ waeup/trunk/src/waeup/tests/test_waeup.py	(revision 4789)
@@ -5,5 +5,12 @@
 """
 import grok
+import zope.component.eventtesting
+from waeup.testing import FunctionalLayer
+
+def setUpZope(test):
+    zope.component.eventtesting.setUp(test)
+
 # Register all tests in the waeup_ng package
 test_suite = grok.testing.register_all_tests(
-    'waeup')
+    'waeup', usetup=setUpZope,
+    layer=FunctionalLayer)
Index: waeup/trunk/src/waeup/university/__init__.py
===================================================================
--- waeup/trunk/src/waeup/university/__init__.py	(revision 3551)
+++ waeup/trunk/src/waeup/university/__init__.py	(revision 4789)
@@ -0,0 +1,1 @@
+# Make this a package.
